diff --git a/Documentation/contents.rst b/Documentation/contents.rst
index befc8f6cc..459c929f3 100644
--- a/Documentation/contents.rst
+++ b/Documentation/contents.rst
@@ -35,8 +35,9 @@ Open vSwitch Documentation Contents
 
    intro/index
    tutorials/index
-   topics/index
    howto/index
+   topics/index
    ref/index
-   faq/index
    internals/index
+   intro/install/documentation
+   faq/index
diff --git a/Documentation/faq/index.rst b/Documentation/faq/index.rst
index 1dd29986a..ff550d6a0 100644
--- a/Documentation/faq/index.rst
+++ b/Documentation/faq/index.rst
@@ -23,9 +23,9 @@
 
       Avoid deeper levels because they do not render well.
 
-================
-Open vSwitch FAQ
-================
+===
+FAQ
+===
 
 .. toctree::
    :maxdepth: 2
diff --git a/Documentation/index.rst b/Documentation/index.rst
index 1f1da2916..3cdc87c69 100644
--- a/Documentation/index.rst
+++ b/Documentation/index.rst
@@ -23,103 +23,56 @@
 
       Avoid deeper levels because they do not render well.
 
-==========================
-Open vSwitch Documentation
-==========================
-
-How the Documentation is Organised
-----------------------------------
-
-The Open vSwitch documentation is organised into multiple sections:
-
-- :doc:`Installation guides </intro/install/index>` guide you through
-  installing Open vSwitch (OVS) on a variety of different platforms
-- :doc:`Tutorials </tutorials/index>` take you through a series of steps to
-  configure OVS in sandboxed environments
-- :doc:`Topic guides </topics/index>` provide a high level overview of OVS
-  internals and operation
-- :doc:`How-to guides </howto/index>` are recipes or use-cases for OVS.
-  They are more advanced than the tutorials.
-- :doc:`Frequently Asked Questions </faq/index>` provide general insight into
-  a variety of topics related to configuration and operation of OVS.
-
-First Steps
------------
-
-Getting started with Open vSwitch (OVS)? Start here.
-
-- **Overview:** :doc:`intro/what-is-ovs` |
-  :doc:`intro/why-ovs`
-
-- **Install:** :doc:`intro/install/general` |
-  :doc:`intro/install/userspace` |
-  :doc:`intro/install/netbsd` |
-  :doc:`intro/install/windows` |
-  :doc:`intro/install/xenserver` |
-  :doc:`intro/install/dpdk` |
-  :doc:`intro/install/afxdp` |
-  :doc:`Installation FAQs <faq/releases>`
-
-- **Tutorials:** :doc:`tutorials/faucet` |
-  :doc:`tutorials/ovs-advanced` |
-  :doc:`tutorials/ovs-conntrack` |
-  :doc:`tutorials/ipsec` |
-
-Deeper Dive
------------
-
-- **Architecture** :doc:`topics/design` |
-  :doc:`topics/openflow` |
-  :doc:`topics/integration` |
-  :doc:`topics/porting` |
-  :doc:`topics/ovs-extensions`
-
-- **DPDK** :doc:`howto/dpdk` |
-  :doc:`topics/dpdk/vhost-user`
+=======
+Project
+=======
 
-- **Windows** :doc:`topics/windows`
+Community
+---------
 
-- **Integrations:** :doc:`topics/language-bindings`
+    - :doc:`internals/mailing-lists`
+    - :doc:`internals/bugs`
+    - :doc:`internals/patchwork`
+    - :doc:`internals/release-process`
+    - :doc:`internals/security`
+    - :doc:`internals/authors`
 
-- **Reference Guides:** :doc:`ref/index`
 
-- **Testing** :doc:`topics/testing` :doc:`topics/fuzzing/index`
+Contributing
+------------
 
-- **Packaging:** :doc:`intro/install/debian` |
-  :doc:`intro/install/rhel` |
-  :doc:`intro/install/fedora`
+    - :doc:`internals/contributing/submitting-patches`
+    - :doc:`internals/contributing/backporting-patches`
+    - :doc:`internals/contributing/coding-style`
+    - :doc:`internals/contributing/coding-style-windows`
 
-The Open vSwitch Project
-------------------------
-
-Learn more about the Open vSwitch project and about how you can contribute:
+Maintaining
+-----------
 
-- **Community:** :doc:`internals/release-process` |
-  :doc:`internals/authors` |
-  :doc:`internals/mailing-lists` |
-  :doc:`internals/patchwork` |
-  :doc:`internals/bugs` |
-  :doc:`internals/security`
+    - :doc:`internals/charter`
+    - :doc:`internals/maintainers`
+    - :doc:`internals/committer-responsibilities`
+    - :doc:`internals/committer-grant-revocation`
+    - :doc:`internals/committer-emeritus-status`
 
-- **Contributing:** :doc:`internals/contributing/submitting-patches` |
-  :doc:`internals/contributing/backporting-patches` |
-  :doc:`internals/contributing/coding-style` |
-  :doc:`internals/contributing/coding-style-windows`
+Documentation
+-------------
 
-- **Maintaining:** :doc:`internals/charter` |
-  :doc:`internals/maintainers` |
-  :doc:`internals/committer-responsibilities` |
-  :doc:`internals/committer-grant-revocation` |
-  :doc:`internals/committer-emeritus-status`
+    - :doc:`intro/index`
+    - :doc:`tutorials/index`
+    - :doc:`howto/index`
+    - :doc:`topics/index`
+    - :doc:`ref/index`
+    - :doc:`internals/index`
+    - :doc:`intro/install/documentation`
+    - :doc:`faq/index`
+    - Looking for specific information?
 
-- **Documentation:** :doc:`internals/contributing/documentation-style` |
-  :doc:`Building Open vSwitch Documentation <intro/install/documentation>` |
-  :doc:`internals/documentation`
+      - :doc:`Full Table of Contents <contents>`
+      - :ref:`Index <genindex>`
 
 Getting Help
 -------------
 
-- Seeing an issue of potential bug? Report problems to bugs@openvswitch.org
+    - Reach out to us :doc:`here <internals/mailing-lists>`.
 
-- Looking for specific information? Try the :ref:`genindex`, :ref:`modindex` or
-  the :doc:`detailed table of contents <contents>`.
diff --git a/Documentation/internals/bugs.rst b/Documentation/internals/bugs.rst
index 116afa9ea..8d493106b 100644
--- a/Documentation/internals/bugs.rst
+++ b/Documentation/internals/bugs.rst
@@ -21,9 +21,9 @@
 
       Avoid deeper levels because they do not render well.
 
-==============================
-Reporting Bugs in Open vSwitch
-==============================
+==============
+Reporting Bugs
+==============
 
 We are eager to hear from users about problems that they have encountered with
 Open vSwitch. This file documents how best to report bugs so as to ensure that
diff --git a/Documentation/internals/contributing/coding-style-windows.rst b/Documentation/internals/contributing/coding-style-windows.rst
index 1edf2285f..d0868f7b3 100644
--- a/Documentation/internals/contributing/coding-style-windows.rst
+++ b/Documentation/internals/contributing/coding-style-windows.rst
@@ -21,9 +21,9 @@
 
       Avoid deeper levels because they do not render well.
 
-==========================================
-Open vSwitch Windows Datapath Coding Style
-==========================================
+=============================
+Windows Datapath Coding Style
+=============================
 
 The :doc:`coding style <coding-style>` guide gives the flexibility for each
 platform to use its own coding style for the kernel datapath.  This file
diff --git a/Documentation/internals/contributing/coding-style.rst b/Documentation/internals/contributing/coding-style.rst
index f70f783ad..7fc320080 100644
--- a/Documentation/internals/contributing/coding-style.rst
+++ b/Documentation/internals/contributing/coding-style.rst
@@ -21,9 +21,9 @@
 
       Avoid deeper levels because they do not render well.
 
-=========================
-Open vSwitch Coding Style
-=========================
+============
+Coding Style
+============
 
 This file describes the coding style used in most C files in the Open vSwitch
 distribution. However, Linux kernel code datapath directory follows the Linux
diff --git a/Documentation/internals/contributing/documentation-style.rst b/Documentation/internals/contributing/documentation-style.rst
index deb07d9f5..045cdf696 100644
--- a/Documentation/internals/contributing/documentation-style.rst
+++ b/Documentation/internals/contributing/documentation-style.rst
@@ -23,9 +23,9 @@
 
       Avoid deeper levels because they do not render well.
 
-================================
-Open vSwitch Documentation Style
-================================
+===================
+Documentation Style
+===================
 
 This file describes the documentation style used in all documentation found in
 Open vSwitch. Documentation includes any documents found in ``Documentation``
diff --git a/Documentation/internals/release-process.rst b/Documentation/internals/release-process.rst
index fb39ccb5d..922d59852 100644
--- a/Documentation/internals/release-process.rst
+++ b/Documentation/internals/release-process.rst
@@ -21,9 +21,9 @@
 
       Avoid deeper levels because they do not render well.
 
-============================
-Open vSwitch Release Process
-============================
+===============
+Release Process
+===============
 
 This document describes the process ordinarily used for Open vSwitch
 development and release.  Exceptions are sometimes necessary, so all of the
diff --git a/Documentation/internals/security.rst b/Documentation/internals/security.rst
index 8b4e5c3f4..444d07c35 100644
--- a/Documentation/internals/security.rst
+++ b/Documentation/internals/security.rst
@@ -21,9 +21,9 @@
 
       Avoid deeper levels because they do not render well.
 
-===============================
-Open vSwitch's Security Process
-===============================
+================
+Security Process
+================
 
 This is a proposed security vulnerability reporting and handling process for
 Open vSwitch. It is based on the OpenStack vulnerability management process